%module md4smb
%{
#include "mdfour.h"
#define MD4_HASHBYTES  16
%}
%include typemaps.i

%typemap(python,in) unsigned char *buffer {
    if (PyString_AsStringAndSize($source, &$target, buffer_length)==-1) {
        PyErr_SetString(PyExc_TypeError,"not a string type");
        return NULL; 
    }
}
%typemap(python,ignore) unsigned int length (unsigned int *buffer_length){
    buffer_length=&$target;
}

#define MD4_HASHBYTES  16
%typemap(python,argout) unsigned char sum[MD4_HASHBYTES] {
    PyObject *o=PyString_FromStringAndSize($source, MD4_HASHBYTES);
    $target = l_output_helper($target,o);
}
%typemap(python,ignore) unsigned char sum[MD4_HASHBYTES] {
    unsigned char temp_sum[MD4_HASHBYTES];
    $target=&temp_sum;
}

/* MD4 context. */
%name(md4) typedef struct rs_mdfour {
    %addmethods {
        rs_mdfour_t() {
            rs_mdfour_t *v;
            v = (rs_mdfour_t *)malloc(sizeof(rs_mdfour_t));
            rs_mdfour_begin(v);
            return v;
        }
        ~rs_mdfour_t() {
            free(self);
        }
        void digest(unsigned char sum[MD4_HASHBYTES]) {
            rs_mdfour_result(self,sum);
        }
        void Update(unsigned char *buffer, unsigned int length) {
            rs_mdfour_update(self,buffer,length);
        }
    }
} rs_mdfour_t;

/*    
void   MD4Init(MD4_CTX *);
void   MD4Update(MD4_CTX *, const unsigned char *, unsigned int);
void   MD4Final(unsigned char [MD4_HASHBYTES], MD4_CTX *);
*/
